#include <stdio.h>
#include <stdlib.h>
#include "AppleSolver.h"

void test(int expected, AppleVectorT *apples, int H, int U)
{
    AppleVectorT *v = cloneAppleVector(apples);
    int actual = solve(v, H, U);
    if (expected != actual)
    {
        printf("expected=%d actual=%d | H=%d U=%d apples=[",
                    expected,   actual,     H,   U);
        for (int i=0; i < v->size; i++)
        {
            if (i) printf(" ");
            printf("(%d, %d)", v->apples[i]->h, v->apples[i]->w);
        }
        printf("]\n");
    }
}

int main()
{
    {
        AppleT data[] = {{82, 30}, {91, 10}, {93,  5}, {94, 15}};
        int n = sizeof(data)/sizeof(data[0]);
        AppleVectorT *v = createApples(n);
        for (int i=0; i < n; i++)
        {
            v->apples[i] = createApple(data[i].h, data[i].w);
        }
        test(45, v, 100, 10);
    }
    {
        AppleT data[] = {{ 1,  1}, { 2,  1}, {81, 10}, {82, 10}};
        int n = sizeof(data)/sizeof(data[0]);
        AppleVectorT *v = createApples(n);
        for (int i=0; i < n; i++)
        {
            v->apples[i] = createApple(data[i].h, data[i].w);
        }
        test(22, v, 100, 10);
    }
    {
        AppleT data[] = {{ 1, 10}, { 2, 10}, {11,  1}};
        int n = sizeof(data)/sizeof(data[0]);
        AppleVectorT *v = createApples(n);
        for (int i=0; i < n; i++)
        {
            v->apples[i] = createApple(data[i].h, data[i].w);
        }
        test(20, v, 20, 10);
    }
    {
        AppleT data[] = {{81, 10}, {82, 10}, {90,  5}};
        int n = sizeof(data)/sizeof(data[0]);
        AppleVectorT *v = createApples(n);
        for (int i=0; i < n; i++)
        {
            v->apples[i] = createApple(data[i].h, data[i].w);
        }
        test(20, v, 100, 10);
    }
    {
        int m = 2147483647; // 2**31 - 1
        AppleT data[] = {{m, 1}};
        int n = sizeof(data)/sizeof(data[0]);
        AppleVectorT *v = createApples(n);
        for (int i=0; i < n; i++)
        {
            v->apples[i] = createApple(data[i].h, data[i].w);
        }
        test(1, v, m, 1);
    }
}
